unit OperazioniVettoriali;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Math;

type
  PTImage = ^TImage;
  TVettore = Class
  private
    Origine: TPoint;
    Vertice: TPoint;
    Intensit: Integer;
    Angol: Integer;
    constructor Create(Sender: TObject);
    function GetIntensita: Integer;
    procedure SetIntensita(const Value: Integer);
    function GetAngolo: Integer;
    procedure SetAngolo(const Value: Integer);
  public
     property Intensita: Integer read GetIntensita write SetIntensita;
     property Angolo: Integer read GetAngolo write SetAngolo;
     function GetVertice: TPoint;
  end;

  TForm1 = class(TForm)
    GroupA: TGroupBox;
    GroupB: TGroupBox;
    GroupSum: TGroupBox;
    GroupDiff: TGroupBox;
    GroupAnteprima: TGroupBox;
    Anteprima: TImage;
    Label1: TLabel;
    Label2: TLabel;
    IntensitaA: TEdit;
    AngoloA: TEdit;
    AngoloB: TEdit;
    Label4: TLabel;
    IntensitaB: TEdit;
    Label5: TLabel;
    AngoloS: TEdit;
    Label3: TLabel;
    IntensitaS: TEdit;
    Label6: TLabel;
    AngoloD: TEdit;
    Label7: TLabel;
    IntensitaD: TEdit;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    Label16: TLabel;
    Label17: TLabel;
    function SommaVettoriale(Const v1,v2: Tvettore): Tvettore;
    function DifferenzaVettoriale(Const v1,v2: Tvettore): Tvettore;
      function ProdottoScalare(Const v1,v2: Tvettore): Real;
      function ProdottoConst(Const K: Real; Const v1: Tvettore): TVettore;
      function ProdottoVettoriale(Const v1,v2: Tvettore): Tvettore;
    procedure FormCreate(Sender: TObject);
    procedure Change(Sender: TObject);
    procedure Disegna(Const Vett: Tvettore; PImage: PTImage; Color: TColor);
    procedure FormResize(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Va,Vb,Vs,Vd: TVettore;


implementation

{$R *.dfm}



{ TVettore }

constructor TVettore.Create(Sender: TObject);
begin
        Self.Intensit := 0;
        Self.Angol := 0;
end;

function TVettore.GetAngolo: Integer;
begin
       Result := Self.Angol;
end;

function TVettore.GetIntensita: Integer;
begin
        Result := Self.Intensit;
end;

function TVettore.GetVertice: TPoint;

begin
        Self.Vertice.X := Trunc(Self.Intensit * cos(Self.Angol*pi/180));
        Self.Vertice.Y := Trunc(Self.Intensit * sin(Self.Angol*pi/180));
        Result := Self.Vertice;
end;

procedure TVettore.SetAngolo(const Value: Integer);

begin
        If Value < 0 Then
         Begin
             Self.Angol := 360 + Value;
         end
        Else
         begin
             Self.Angol := Value;
         end;


end;

procedure TVettore.SetIntensita(const Value: Integer);
begin
        Self.Intensit := Value;
end;






function TForm1.SommaVettoriale(Const v1,v2: Tvettore): Tvettore;
var
        Vertice1x,Vertice2x,Vertice1y,Vertice2y: Extended;
        VSomma: Tvettore;
        ExtendTemp: Extended;
begin
        VSomma := TVettore.Create(Self);
        Vertice1x := v1.Intensita*cos(v1.Angolo*pi/180);
        Vertice1y := v1.Intensita*sin(v1.Angolo*pi/180);
        Vertice2x := v2.Intensita*cos(v2.Angolo*pi/180);
        Vertice2y := v2.Intensita*sin(v2.Angolo*pi/180);

        Self.Label9.Caption := 'V1x = ' + IntToStr(Trunc(Vertice1x));
        Self.Label10.Caption := 'V1y = ' + IntToStr(Trunc(Vertice1y));
        Self.Label11.Caption := 'V2x = ' + IntToStr(Trunc(Vertice2x));
        Self.Label12.Caption := 'V2y = ' + IntToStr(Trunc(Vertice2y));

        VSomma.Intensita := Trunc(Sqrt(Sqr((Vertice1x + Vertice2x)) + Sqr((Vertice1y + Vertice2y)))) ;

        ExtendTemp :=  (180/pi)*ArcTan2((Vertice1y + Vertice2y),(Vertice1x + Vertice2x));

        VSomma.Angolo := Trunc(ExtendTemp);

        Self.Label13.Caption := 'Vsx = ' + IntToStr(VSomma.GetVertice.X);
        Self.Label14.Caption := 'Vsy = ' + IntToStr(VSomma.GetVertice.Y);

        Self.IntensitaS.Text := IntToStr(VSomma.Intensita);
        Self.AngoloS.Text := IntToStr(VSomma.Angolo);

        Result := VSomma;
        //VSomma.Destroy;
end;

function TForm1.DifferenzaVettoriale(Const v1,v2: Tvettore): Tvettore;
var
        Vertice1x,Vertice2x,Vertice1y,Vertice2y: Extended;
        VDifferenza: Tvettore;
        ExtendTemp: Extended;
begin
        VDifferenza := TVettore.Create(Self);
        Vertice1x := v1.Intensita*cos(v1.Angolo*pi/180);
        Vertice1y := v1.Intensita*sin(v1.Angolo*pi/180);
        Vertice2x := v2.Intensita*cos(v2.Angolo*pi/180);
        Vertice2y := v2.Intensita*sin(v2.Angolo*pi/180);

        Self.Label9.Caption := 'V1x = ' + IntToStr(Trunc(Vertice1x));
        Self.Label10.Caption := 'V1y = ' + IntToStr(Trunc(Vertice1y));
        Self.Label11.Caption := 'V2x = ' + IntToStr(Trunc(Vertice2x));
        Self.Label12.Caption := 'V2y = ' + IntToStr(Trunc(Vertice2y));

        VDifferenza.Intensita := Trunc(Sqrt(Sqr((Vertice1x - Vertice2x)) + Sqr((Vertice1y - Vertice2y)))) ;

        ExtendTemp :=  (180/pi)*ArcTan2((Vertice1y - Vertice2y),(Vertice1x - Vertice2x));

        VDifferenza.Angolo := Trunc(ExtendTemp);

        Self.Label15.Caption := 'Vdx = ' + IntToStr(VDifferenza.GetVertice.X);
        Self.Label16.Caption := 'Vdy = ' + IntToStr(VDifferenza.GetVertice.Y);

        Self.IntensitaD.Text := IntToStr(VDifferenza.Intensita);
        Self.AngoloD.Text := IntToStr(VDifferenza.Angolo);

        Result := VDifferenza;
        //VDifferenza.Destroy;
end;

function TForm1.ProdottoScalare(const v1, v2: Tvettore): Real;
Var
        temp: String;
begin
        Str((abs(v1.Intensita)*abs(v2.Intensita)*sin(abs(v1.Angolo-v2.Angolo)*pi/180)):10:2,temp);
        Self.Label17.Caption := 'a Scalar b = ' + temp;
        Result := abs(v1.Intensita)*abs(v2.Intensita)*sin(abs(v1.Angolo-v2.Angolo)*pi/180);

end;

function TForm1.ProdottoConst(const K: Real;
  const v1: Tvettore): Tvettore;
var
        Vertice1x,Vertice1y: Extended;
        VResult: Tvettore;
        ExtendTemp: Extended;
begin
        VResult := TVettore.Create(Self);
        VResult.Intensita := Trunc(v1.Intensita*K) ;
        VResult.Angolo := v1.Angolo;

        Result := VResult;
        //VDifferenza.Destroy;
end;

function TForm1.ProdottoVettoriale(const v1,
  v2: Tvettore): Tvettore;
begin
     //
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
        Va := Tvettore.Create(Self);
        Vb := Tvettore.Create(Self);
        Vs := Tvettore.Create(Self);
        Vd := Tvettore.Create(Self);
        Self.Image1.Canvas.Brush.Color := clGreen;
        Self.Image1.Canvas.FloodFill(0,0,clGreen,fsBorder);
        Self.Image2.Canvas.Brush.Color := clBlue;
        Self.Image2.Canvas.FloodFill(0,0,clBlue,fsBorder);
        Self.Image3.Canvas.Brush.Color := clRed;
        Self.Image3.Canvas.FloodFill(0,0,clRed,fsBorder);
        Self.Image4.Canvas.Brush.Color := clWhite;
        Self.Image4.Canvas.FloodFill(0,0,clWhite,fsBorder);
        Self.Change(Self)
end;   

procedure TForm1.Change(Sender: TObject);
begin
    If ((Not(Self.IntensitaA.Text=''))And(Not(Self.AngoloA.Text=''))) Then
     Begin
             Self.Anteprima.Canvas.Brush.Color := clBtnFace;
             Self.Anteprima.Canvas.Brush.Style := bsSolid;
             Self.Anteprima.Canvas.FloodFill(0,0,clInactiveBorder,fsBorder);
             Self.Anteprima.Canvas.Pen.Color := clBlack;
             Self.Anteprima.Canvas.MoveTo(0,Trunc(Self.Anteprima.Height/2));
             Self.Anteprima.Canvas.LineTo(Self.Anteprima.Width,Trunc(Self.Anteprima.Height/2));
             Self.Anteprima.Canvas.MoveTo(Trunc(Self.Anteprima.Width/2),0);
             Self.Anteprima.Canvas.LineTo(Trunc(Self.Anteprima.Width/2),Self.Anteprima.Height);

             Va.Intensita := StrToInt(Self.IntensitaA.Text);
             Va.Angolo := StrToInt(Self.AngoloA.Text);
             Self.Disegna(Va,@Self.Anteprima,clGreen);
             If ((Not(Self.IntensitaB.Text=''))And(Not(Self.AngoloB.Text=''))) Then
               Begin
                        Vb.Intensita := StrToInt(Self.IntensitaB.Text);
                        Vb.Angolo := StrToInt(Self.AngoloB.Text);
                        Vs := Self.SommaVettoriale(va,vb);
                        Vd := Self.DifferenzaVettoriale(va,vb);
                        Self.Disegna(Vb,@Self.Anteprima,clBlue);
                        Self.Disegna(Vs,@Self.Anteprima,clRed);
                        Self.Disegna(Vd,@Self.Anteprima,clWhite);
                        Self.ProdottoScalare(va,vb);

               End;
     End;

end;

procedure Tform1.Disegna(Const Vett: Tvettore; PImage: PTImage; Color: TColor);
Var
        ImageCenter,Vertice: TPoint;
begin
       ImageCenter.X := Trunc(PImage^.Width/2);
       ImageCenter.Y := Trunc(PImage^.Height/2);
       Vertice := Vett.GetVertice;
       PImage^.Canvas.Pen.Color := Color;
       PImage^.Canvas.MoveTo(ImageCenter.X,ImageCenter.Y);
       PImage^.Canvas.LineTo((ImageCenter.X + Vertice.X),(ImageCenter.Y - Vertice.Y));

       {-- Disegna la freccetta --}
       PImage^.Canvas.MoveTo((ImageCenter.X + Vertice.X),(ImageCenter.Y - Vertice.Y));
       PImage^.Canvas.LineTo(((ImageCenter.X + Vertice.X) + Trunc(-10*cos((Vett.Angolo+30)*pi/180))),((ImageCenter.Y - Vertice.Y - Trunc(-10*sin((Vett.Angolo+30)*pi/180)))));
       PImage^.Canvas.MoveTo((ImageCenter.X + Vertice.X),(ImageCenter.Y - Vertice.Y));
       PImage^.Canvas.LineTo(((ImageCenter.X + Vertice.X) + Trunc(10*cos((Vett.Angolo+180-30)*pi/180))),(ImageCenter.Y - Vertice.Y - Trunc(10*sin((Vett.Angolo+180-30)*pi/180))));

end;


procedure TForm1.FormResize(Sender: TObject);
begin
        //Self.GroupAnteprima.Width := Self.Width;
        //Self.GroupAnteprima.Height := Self.Height - Self.GroupAnteprima.Top ;
        //Self.Anteprima.Width := Self.GroupAnteprima.Width-5;
        //Self.Anteprima.Height := Self.GroupAnteprima.Height - Self.GroupAnteprima.Top -5;
end;

end.
